# coding: utf-8

require 'erb'

class OrgCreate
   @@erb = File::read(File::expand_path("../../erb/org.xml.erb", __FILE__), :encoding => 'UTF-8')
   
   attr_accessor :prefix, :rank, :org_id, :parent_org_id, :comment
   
   def self.rank_array=(r)
      @@rank_array = r
   end
   
   def self.rank_array
      @@rank_array
   end
   
   def org_abb
      "略称-#{org_id}"
   end
   
   def org_name
      "組織-#{org_id}"
   end
   
   def to_xml
      ERB.new(@@erb, nil, '-').result(binding)
   end
   
   def generate_children_recursive(data)
      
      childern_num = @@rank_array[self.rank + 1].nil? ? 0 : @@rank_array[self.rank + 1] - 1
      return if childern_num <= 0
      
      0.upto(@@rank_array[self.rank + 1] - 1) do |i|
         o = OrgCreate.new
         o.org_id = "#{self.org_id}-#{"%03d" % i}"
         o.parent_org_id = self.org_id
         o.rank = self.rank + 1
         o.comment = "#{self.comment}/#{o.org_id}"
         data << o
         
         o.generate_children_recursive(data)
      end
   end
end